package com.alterdekim.game.entity;

import com.alterdekim.game.xml.NumericBooleanSerializer;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRootName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="phone_messages")
@JsonRootName(value = "item")
public class PhoneMessage {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @JsonProperty
    private Long Id;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private String DateSent;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private Long SenderId;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private String SenderName;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    private String Text;

    @JsonProperty
    @JacksonXmlProperty(isAttribute = true)
    @Column(nullable = false)
    @JsonSerialize(using= NumericBooleanSerializer.class)
    private Boolean IsNew;
}
