package com.alterdekim.game.repository;

import com.alterdekim.game.component.game.AvatarInventoryType;
import com.alterdekim.game.entity.AvatarInventory;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface AvatarInventoryRepository extends JpaRepository<AvatarInventory, Long> {

    @Query(value = "SELECT a FROM AvatarInventory a WHERE a.userId = :uid AND a.type = :type")
    List<AvatarInventory> findItemsByUserIdAndType(@Param("uid") Long userId, @Param("type") AvatarInventoryType type);

    @Query(value = "SELECT a FROM AvatarInventory a WHERE a.userId = :uid AND a.type = :type AND a.isUsed = true")
    List<AvatarInventory> findUsedItemsByUserIdAndType(@Param("uid") Long userId, @Param("type") AvatarInventoryType type);

    @Query(value = "SELECT a.isUsed FROM AvatarInventory a WHERE a.userId = :userId AND a.type = :type AND a.goodId = :goodId")
    Boolean getIsUsed(@Param("userId") Long userId, @Param("type") AvatarInventoryType type, @Param("goodId") Long goodId);
}
